#include "rawSuperResolution.h"

void PSF(const Mat &input, Mat &output, double xscale, double yscale){
	int block_x, block_y;
	int intxscale = cvCeil(xscale);
	int intyscale = cvCeil(yscale);

	if (intxscale % 2 == 0) block_x = intxscale + 1;
	else block_x = intxscale;
	if (intyscale % 2 == 0) block_y = intyscale + 1;
	else block_y = intyscale;

	double edge_xw = (xscale - (double)(block_x - 2)) / 2.0;
	double edge_yw = (yscale - (double)(block_y - 2)) / 2.0;

	double weight = 0.0;
	Mat karnel(block_y, block_x, CV_64F);
	double *karnel_p = karnel.ptr<double>(0);
	for (int i = 0; i<block_y; i++){
		for (int j = 0; j<block_x; j++){
			if (i == 0 || i == block_y - 1) *karnel_p = edge_yw;
			else *karnel_p = 1.0;

			if (j == 0 || j == block_x - 1) *karnel_p = *karnel_p * edge_xw;
			else;

			weight += *karnel_p;

			karnel_p++;
		}
	}
	karnel = karnel / weight;

	int w_x, w_y;
	w_x = (block_x - 1) / 2;
	w_y = (block_y - 1) / 2;

	output = Mat::zeros(input.rows, input.cols, CV_32FC3);
	Vec3f *outputp = output.ptr<Vec3f>(0);
	for (int i = 0; i<input.rows; i++){
		for (int j = 0; j<input.cols; j++){
			karnel_p = karnel.ptr<double>(0);
			for (int k = -w_y; k<w_y + 1; k++){
				for (int l = -w_x; l<w_x + 1; l++){
					if (i + k >= 0 && i + k<input.rows && j + l >= 0 && j + l<input.cols){
						(*outputp)[0] += (float)(*karnel_p)*input.at<Vec3f>(i + k, j + l)[0];
						(*outputp)[1] += (float)(*karnel_p)*input.at<Vec3f>(i + k, j + l)[1];
						(*outputp)[2] += (float)(*karnel_p)*input.at<Vec3f>(i + k, j + l)[2];
					}
					karnel_p++;
				}
			}
			outputp++;
		}
	}


}