#include "rawSuperResolution.h"

#define RAW_FILE "./raw/watch1_WB.tiff"		// RAW image
#define COLOR_FILE "./raw/watch1RGB_WB.tiff"	// RAW image after demosaicing

int main(void)
{
	// parameter for rawDepthEstimation
	int blockSize = 9;
	// parameters for rawSuperResolution
	int iteration = 15;
	int iterationx = 3;
	double lambda = 3.0;
	double rho = 1.0;
	bool joint_flag = true;
	bool yuv_flag = true;

	clock_t start = clock();
	//-------------------------------------------------------------------------------------
	// direct method + prior L1 norm
	Mat *subaperture = new Mat[FRAME];
	Mat HR(high_y, high_x, CV_32FC3);
	Mat LR;
	Mat *mask = new Mat[FRAME];
	viewCreate *VC = new viewCreate(COLOR_FILE, RAW_FILE);
	VC->create_mask(subaperture, mask, LR);
	delete VC;
	resize(LR, HR, Size(high_x, high_y), 0, 0, INTER_CUBIC);
	char str[64], str2[64];
	strcpy(str, FOLDER);
	sprintf(str2, "bicubic.ppm");
	strcat(str, str2);
	imwrite(str, HR);
	Mat disparity(HR.rows, HR.cols, CV_32FC1, Scalar(0, 0, 0));
	rawDepthEstimation *DE = new rawDepthEstimation(-1, 1, blockSize);
	DE->estimate_rawdepth(HR, subaperture, mask, disparity);
	delete DE;
	rawSuperResolution *RSR = new rawSuperResolution(iteration, iterationx, lambda, rho);
	RSR->raw_super_resolution(HR, subaperture, mask, disparity, joint_flag, yuv_flag);
	delete RSR;
	delete[] subaperture;
	delete[] mask;
	//-------------------------------------------------------------------------------------
	cout << "finish" << endl;
	clock_t end = clock();
	::cout << "duration = " << (double)(end - start) / CLOCKS_PER_SEC << "sec." << endl;
	getchar();

	return 0;
}
